/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Russell Boykin       - initial API and implementation
 *     Alberto Giammaria    - initial API and implementation
 *     Chris Peters         - initial API and implementation
 *     Gianluca Bernardini  - initial API and implementation
 *	   Sam Padgett          - initial API and implementation
 *     Michael Fiedler      - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse
 *     .org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Support for multiple Service Providers.
 *     Anass Radouani       - Support for multiple Service Providers.
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.aide.oslc.ccm;

//import assume.adaptors.code.demo.resources.Person;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import javax.ws.rs.core.UriBuilder;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDescription;
import org.eclipse.lyo.oslc4j.core.annotation.OslcName;
import org.eclipse.lyo.oslc4j.core.annotation.OslcNamespace;
import org.eclipse.lyo.oslc4j.core.annotation.OslcOccurs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcPropertyDefinition;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRange;
import org.eclipse.lyo.oslc4j.core.annotation.OslcReadOnly;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRepresentation;
import org.eclipse.lyo.oslc4j.core.annotation.OslcResourceShape;
import org.eclipse.lyo.oslc4j.core.annotation.OslcTitle;
import org.eclipse.lyo.oslc4j.core.annotation.OslcValueType;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.Occurs;
import org.eclipse.lyo.oslc4j.core.model.Representation;
import org.eclipse.lyo.oslc4j.core.model.ValueType;

@OslcNamespace(ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_NAMSPACE)
@OslcName(ConfigurationManagementConstants.VERSIONRESOURCE)
@OslcResourceShape(title = "VersionResource Resource Shape",
                   describes = ConfigurationManagementConstants.TYPE_VERSIONRESOURCE)
public class VersionResource extends AbstractResource implements IVersionResource {

  private Link contributor = new Link();

  private Date created;

  private Link creator = new Link();

  private String description;

  private String identifier;

  private Link isVersionOf = new Link();

  private Date modified;

  private String subject;

  private String title;

  private Date committed;

  private HashSet<Link> committer = new HashSet<Link>();

  private HashSet<String> component = new HashSet<String>();

  private String versionId;

  private URI instanceShape;

  private Link modifiedBy = new Link();

  private URI serviceProvider;

  private String shortId;

  private String shortTitle;

  private Link type = new Link();

  private HashSet<Link> wasDerivedFrom = new HashSet<Link>();

  private HashSet<Link> wasRevisionOf = new HashSet<Link>();

  public VersionResource() throws URISyntaxException {
    super();


  }

  public VersionResource(final String serviceProviderId, final String resourceId,
      final String versionId, final String basePath) throws URISyntaxException {
    this(constructURI(serviceProviderId, resourceId, versionId, basePath));

  }

  public VersionResource(final URI about) throws URISyntaxException {
    super(about);


  }

  public static URI constructURI(final String serviceProviderId, final String resourceId,
      final String versionId, final String basePath) {
    Map<String, Object> pathParameters = new HashMap<String, Object>();
    pathParameters.put("serviceProviderId", serviceProviderId);
    pathParameters.put("resourceId", resourceId);
    pathParameters.put("versionId", versionId);
    String instanceURI = "ccm-services/{serviceProviderId}/resources/versionResources" +
        "" + "" + "/{resourceId}/{versionId}";

    final UriBuilder builder = UriBuilder.fromUri(basePath);
    return builder.path(instanceURI).buildFromMap(pathParameters);
  }

  public static Link constructLink(final String serviceProviderId, final String resourceId,
      final String versionId, final String label, final String basePath) {
    return new Link(constructURI(serviceProviderId, resourceId, versionId, basePath), label);
  }

  public static Link constructLink(final String serviceProviderId, final String resourceId,
      final String versionId, final String basePath) {
    return new Link(constructURI(serviceProviderId, resourceId, versionId, basePath));
  }

  static public String contributorToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"contributor\">contributor: </LABEL>";

    return s;
  }

  static public String createdToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"created\">created: </LABEL>";

    s = s + "<input name=\"created\" type=\"text\" style=\"width: 400px\" id=\"created\" >";

    return s;
  }

  static public String creatorToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"creator\">creator: </LABEL>";

    return s;
  }

  static public String descriptionToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"description\">description: </LABEL>";

    s = s + "<input name=\"description\" type=\"text\" style=\"width: 400px\" id=\"description\" >";

    return s;
  }

  static public String identifierToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"identifier\">identifier: </LABEL>";

    s = s + "<input name=\"identifier\" type=\"text\" style=\"width: 400px\" id=\"identifier\" >";

    return s;
  }

  static public String isVersionOfToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"isVersionOf\">isVersionOf: </LABEL>";

    return s;
  }

  static public String modifiedToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"modified\">modified: </LABEL>";

    s = s + "<input name=\"modified\" type=\"text\" style=\"width: 400px\" id=\"modified\" >";

    return s;
  }

  static public String subjectToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"subject\">subject: </LABEL>";

    s = s + "<input name=\"subject\" type=\"text\" style=\"width: 400px\" id=\"subject\" >";

    return s;
  }

  static public String titleToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"title\">title: </LABEL>";

    s = s + "<input name=\"title\" type=\"text\" style=\"width: 400px\" id=\"title\" >";

    return s;
  }

  static public String committedToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"committed\">committed: </LABEL>";

    s = s + "<input name=\"committed\" type=\"text\" style=\"width: 400px\" id=\"committed\" >";

    return s;
  }

  static public String committerToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"committer\">committer: </LABEL>";

    return s;
  }

  static public String componentToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"component\">component: </LABEL>";

    s = s + "<input name=\"component\" type=\"text\" style=\"width: 400px\" id=\"component\" >";

    return s;
  }

  static public String versionIdToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"versionId\">versionId: </LABEL>";

    s = s + "<input name=\"versionId\" type=\"text\" style=\"width: 400px\" id=\"versionId\" >";

    return s;
  }

  static public String instanceShapeToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"instanceShape\">instanceShape: </LABEL>";

    s = s + "<input name=\"instanceShape\" type=\"text\" style=\"width: 400px\" " +
        "id=\"instanceShape\" >";

    return s;
  }

  static public String modifiedByToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"modifiedBy\">modifiedBy: </LABEL>";

    return s;
  }

  static public String serviceProviderToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"serviceProvider\">serviceProvider: </LABEL>";

    s = s + "<input name=\"serviceProvider\" type=\"text\" style=\"width: 400px\" " +
        "id=\"serviceProvider\" >";

    return s;
  }

  static public String shortIdToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"shortId\">shortId: </LABEL>";

    s = s + "<input name=\"shortId\" type=\"text\" style=\"width: 400px\" id=\"shortId\" >";

    return s;
  }

  static public String shortTitleToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"shortTitle\">shortTitle: </LABEL>";

    s = s + "<input name=\"shortTitle\" type=\"text\" style=\"width: 400px\" id=\"shortTitle\" >";

    return s;
  }

  static public String typeToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"type\">type: </LABEL>";

    return s;
  }

  static public String wasDerivedFromToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"wasDerivedFrom\">wasDerivedFrom: </LABEL>";

    return s;
  }

  static public String wasRevisionOfToHtmlForCreation() {
    String s = "";

    s = s + "<label for=\"wasRevisionOf\">wasRevisionOf: </LABEL>";

    return s;
  }

  public String toHtml() {
    return toHtml(false);
  }

  public String toHtml(boolean asLocalResource) {
    String result = "";

    if (asLocalResource) {
      result = toString(true);

    } else {
      result = "<a href=\"" + getAbout() + "\">" + toString() + "</a>";
    }

    return result;
  }

  public String toString() {
    return toString(false);
  }

  public String toString(boolean asLocalResource) {
    String result = "";


    if (asLocalResource) {
      result = result + "{a Local VersionResource Resource} - update VersionResource.toString() "
          + "to present resource as desired.";

    } else {
      result = getAbout().toString();
    }



    return result;
  }

  public void addCommitter(final Link committer) {
    this.committer.add(committer);
  }

  public void addComponent(final String component) {
    this.component.add(component);
  }

  public void addWasDerivedFrom(final Link wasDerivedFrom) {
    this.wasDerivedFrom.add(wasDerivedFrom);
  }

  public void addWasRevisionOf(final Link wasRevisionOf) {
    this.wasRevisionOf.add(wasRevisionOf);
  }

  @OslcName("contributor")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "contributor")
  @OslcDescription(
      "Contributor or contributors to the resource. It is likely that the target resource will "
          + "be" + " a foaf:Person but that is not necessarily the case.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.Resource)
  @OslcRange({ConfigurationManagementConstants.TYPE_PERSON})
  @OslcReadOnly(false)
  public Link getContributor() {

    return contributor;
  }

  public void setContributor(final Link contributor) {

    this.contributor = contributor;

  }

  @OslcName("created")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "created")
  @OslcDescription("Timestamp of resource creation")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.DateTime)
  @OslcReadOnly(false)
  public Date getCreated() {

    return created;
  }

  public void setCreated(final Date created) {

    this.created = created;

  }

  @OslcName("creator")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "creator")
  @OslcDescription(
      "Creator or creators of the resource. It is likely that the target resource will be a " +
          "foaf:Person but that is not necessarily the case.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.Resource)
  @OslcRange({ConfigurationManagementConstants.TYPE_PERSON})
  @OslcReadOnly(false)
  public Link getCreator() {

    return creator;
  }

  public void setCreator(final Link creator) {

    this.creator = creator;

  }

  @OslcName("description")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "description")
  @OslcDescription(
      "Descriptive text about resource represented as rich text in XHTML content. SHOULD include " +
          "" + "" + "only content that is valid and suitable inside an XHTML <div> element.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.XMLLiteral)
  @OslcReadOnly(false)
  public String getDescription() {

    return description;
  }

  public void setDescription(final String description) {

    this.description = description;

  }

  @OslcName("identifier")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "identifier")
  @OslcDescription(
      "A unique identifier for a resource. Typically read-only and assigned by the service " +
          "provider when a resource is created. Not typically intended for end-user display.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.String)
  @OslcReadOnly(false)
  public String getIdentifier() {

    return identifier;
  }

  public void setIdentifier(final String identifier) {

    this.identifier = identifier;

  }

  @OslcName("isVersionOf")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "isVersionOf")
  @OslcDescription(
      "The concept resource of which this resource is a version. The subject of this property " +
          "must be the version resource URI.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.Resource)
  @OslcRepresentation(Representation.Reference)
  @OslcReadOnly(false)
  public Link getIsVersionOf() {

    return isVersionOf;
  }

  public void setIsVersionOf(final Link isVersionOf) {

    this.isVersionOf = isVersionOf;

  }

  @OslcName("modified")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "modified")
  @OslcDescription("Timestamp of latest resource modification")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.DateTime)
  @OslcReadOnly(false)
  public Date getModified() {

    return modified;
  }

  public void setModified(final Date modified) {

    this.modified = modified;

  }

  @OslcName("subject")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "subject")
  @OslcDescription(
      "Tag or keyword for a resource. Each occurrence of a dcterms:subject property denotes an "
          + "additional tag for the resource.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.String)
  @OslcReadOnly(false)
  @OslcTitle("")
  public String getSubject() {

    return subject;
  }

  public void setSubject(final String subject) {

    this.subject = subject;

  }

  @OslcName("title")
  @OslcPropertyDefinition(ConfigurationManagementConstants.DUBLIN_CORE_NAMSPACE + "title")
  @OslcDescription(
      "Title of the resource represented as rich text in XHTML content. SHOULD include only " +
          "content that is valid inside an XHTML <span> element.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.XMLLiteral)
  @OslcReadOnly(false)
  public String getTitle() {

    return title;
  }

  public void setTitle(final String title) {

    this.title = title;

  }

  @OslcName("committed")
  @OslcPropertyDefinition(
      ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_NAMSPACE + "committed")
  @OslcDescription(
      "Date and time this version resource was checked in. Absent for mutable (checked out) " +
          "versions.")
  @OslcOccurs(Occurs.ZeroOrOne)
  @OslcValueType(ValueType.DateTime)
  @OslcReadOnly(false)
  public Date getCommitted() {

    return committed;
  }

  public void setCommitted(final Date committed) {

    this.committed = committed;

  }

  @OslcName("committer")
  @OslcPropertyDefinition(
      ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_NAMSPACE + "committer")
  @OslcDescription("The entity that checked in this version.")
  @OslcOccurs(Occurs.ZeroOrMany)
  @OslcValueType(ValueType.Resource)
  @OslcReadOnly(true)
  public HashSet<Link> getCommitter() {

    return committer;
  }

  public void setCommitter(final HashSet<Link> committer) {

    this.committer.clear();
    if (committer != null) {
      this.committer.addAll(committer);
    }

  }

  @OslcName("component")
  @OslcPropertyDefinition(
      ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_NAMSPACE + "component")
  @OslcDescription(
      "The component to which this version belongs. Configuration Management provider should " +
          "indicate the owning component for each version resource using either this property, "
          + "or" + " using the membership relationship from the component LDPC.")
  @OslcOccurs(Occurs.ZeroOrMany)
  @OslcValueType(ValueType.String)
  @OslcReadOnly(false)
  public HashSet<String> getComponent() {

    return component;
  }

  public void setComponent(final HashSet<String> component) {

    this.component.clear();
    if (component != null) {
      this.component.addAll(component);
    }

  }

  @OslcName("versionId")
  @OslcPropertyDefinition(
      ConfigurationManagementConstants.CONFIGURATION_MANAGEMENT_NAMSPACE + "versionId")
  @OslcDescription(
      "A short human-readable identifier for the version of a resource. All versioned resources "
          + "should have this property; where the property is present, this identifier must be "
          + "unique amongst all currently existing versions of the same concept resource. The " +
          "subject of this property should be the concept resource URI.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.String)
  @OslcReadOnly(false)
  public String getVersionId() {

    return versionId;
  }

  public void setVersionId(final String versionId) {

    this.versionId = versionId;

  }

  @OslcName("instanceShape")
  @OslcPropertyDefinition(ConfigurationManagementConstants.OSLC_NAMSPACE + "instanceShape")
  @OslcDescription(
      "The URI of a Resource Shape that describes the possible properties, occurrence, value " +
          "types, allowed values and labels. This shape information is useful in displaying the "
          + "subject resource as well as guiding clients in performing modifications. Instance "
          + "shapes may be specific to the authenticated user associated with the request that "
          + "retrieved the resource, the current state of the resource and other factors and " +
          "thus" + " " + "should not be cached.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcReadOnly(false)
  public URI getInstanceShape() {

    return instanceShape;
  }

  public void setInstanceShape(final URI instanceShape) {

    this.instanceShape = instanceShape;

  }

  @OslcName("modifiedBy")
  @OslcPropertyDefinition(ConfigurationManagementConstants.OSLC_NAMSPACE + "modifiedBy")
  @OslcDescription(
      "The URI of a resource describing the entity that most recently modified the subject " +
          "resource. The link target is usually a foaf:Person or foaf:Agent, but could be any " +
          "type. This is modeled after dcterms:creator, but Dublin Core currently has no " +
          "equivalent property.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.Resource)
  @OslcReadOnly(false)
  public Link getModifiedBy() {

    return modifiedBy;
  }

  public void setModifiedBy(final Link modifiedBy) {

    this.modifiedBy = modifiedBy;

  }

  @OslcName("serviceProvider")
  @OslcPropertyDefinition(ConfigurationManagementConstants.OSLC_NAMSPACE + "serviceProvider")
  @OslcDescription(
      "A link to the resource's OSLC Service Provider. There may be cases when the subject " +
          "resource is available from a service provider that implements multiple domain " +
          "specifications, which could result in multiple values for this property.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcReadOnly(false)
  public URI getServiceProvider() {

    return serviceProvider;
  }

  public void setServiceProvider(final URI serviceProvider) {

    this.serviceProvider = serviceProvider;

  }

  @OslcName("shortId")
  @OslcPropertyDefinition(ConfigurationManagementConstants.OSLC_NAMSPACE + "shortId")
  @OslcDescription("Shorter form of dcterms:identifier for the resource, such as a number.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.String)
  @OslcReadOnly(false)
  public String getShortId() {

    return shortId;
  }

  public void setShortId(final String shortId) {

    this.shortId = shortId;

  }

  @OslcName("shortTitle")
  @OslcPropertyDefinition(ConfigurationManagementConstants.OSLC_NAMSPACE + "shortTitle")
  @OslcDescription(
      "Shorter form of dcterms:title for the resource represented as rich text in XHTML content. " +
          "" + "" + "SHOULD include only content that is valid inside an XHTML <span> element.")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.XMLLiteral)
  @OslcReadOnly(false)
  public String getShortTitle() {

    return shortTitle;
  }

  public void setShortTitle(final String shortTitle) {

    this.shortTitle = shortTitle;

  }

  @OslcName("type")
  @OslcPropertyDefinition(ConfigurationManagementConstants.RDF_NAMSPACE + "type")
  @OslcDescription("The resource type URIs")
  @OslcOccurs(Occurs.ExactlyOne)
  @OslcValueType(ValueType.Resource)
  @OslcReadOnly(false)
  public Link getType() {

    return type;
  }

  public void setType(final Link type) {

    this.type = type;

  }

  @OslcName("wasDerivedFrom")
  @OslcPropertyDefinition(ConfigurationManagementConstants.PROVENANCE_NAMSPACE + "wasDerivedFrom")
  @OslcDescription(
      "A resource from which this version was derived. This is likely to reference a different "
          + "concept resource; use of prov:wasRevisionOf is recommended to indicate an earlier "
          + "version of the same concept resource. The subject of each instance of this property " +
          "" + "" + "must be the concept resource URI; the object can be a version resource URI, " +
          "or a " + "" + "concept resource URI (possibly for a non-versioned resource).")
  @OslcOccurs(Occurs.ZeroOrMany)
  @OslcValueType(ValueType.Resource)
  @OslcRepresentation(Representation.Reference)
  @OslcReadOnly(false)
  public HashSet<Link> getWasDerivedFrom() {

    return wasDerivedFrom;
  }

  public void setWasDerivedFrom(final HashSet<Link> wasDerivedFrom) {

    this.wasDerivedFrom.clear();
    if (wasDerivedFrom != null) {
      this.wasDerivedFrom.addAll(wasDerivedFrom);
    }

  }

  @OslcName("wasRevisionOf")
  @OslcPropertyDefinition(ConfigurationManagementConstants.PROVENANCE_NAMSPACE + "wasRevisionOf")
  @OslcDescription(
      "A resource from which this version was derived. This is likely to reference an earlier " +
          "version of the same concept resource; use of prov:wasDerivedFrom is recommended to " +
          "indicate an earlier version of a different concept resource. The subject of each " +
          "instance of this property must be the concept resource URI; the object is likely to "
          + "be" + " a version resource URI.")
  @OslcOccurs(Occurs.ZeroOrMany)
  @OslcValueType(ValueType.Resource)
  @OslcRepresentation(Representation.Reference)
  @OslcReadOnly(false)
  public HashSet<Link> getWasRevisionOf() {

    return wasRevisionOf;
  }

  public void setWasRevisionOf(final HashSet<Link> wasRevisionOf) {

    this.wasRevisionOf.clear();
    if (wasRevisionOf != null) {
      this.wasRevisionOf.addAll(wasRevisionOf);
    }

  }

  public String contributorToHtml() {
    String s = "";

    s = s + "<label for=\"contributor\"><strong>contributor</strong>: &nbsp;</LABEL>";

    try {
      if (contributor.getValue() != null) {
        s = s + contributor.getValue();
      } else {
        s = s + "<em>null</em>";
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String createdToHtml() {
    String s = "";

    s = s + "<label for=\"created\"><strong>created</strong>: &nbsp;</LABEL>";

    try {
      if (created == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + created.toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String creatorToHtml() {
    String s = "";

    s = s + "<label for=\"creator\"><strong>creator</strong>: &nbsp;</LABEL>";

    try {
      if (creator.getValue() != null) {
        s = s + contributor.getValue();
      } else {
        s = s + "<em>null</em>";
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String descriptionToHtml() {
    String s = "";

    s = s + "<label for=\"description\"><strong>description</strong>: &nbsp;</LABEL>";

    try {
      if (description == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + description.toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String identifierToHtml() {
    String s = "";

    s = s + "<label for=\"identifier\"><strong>identifier</strong>: &nbsp;</LABEL>";

    try {
      if (identifier == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + identifier.toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String isVersionOfToHtml() {
    String s = "";

    s = s + "<label for=\"isVersionOf\"><strong>isVersionOf</strong>: &nbsp;</LABEL>";

    try {
      if (isVersionOf.getValue() == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + isVersionOf.getValue().toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String modifiedToHtml() {
    String s = "";

    s = s + "<label for=\"modified\"><strong>modified</strong>: &nbsp;</LABEL>";

    try {
      if (modified == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + modified.toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String subjectToHtml() {
    String s = "";

    s = s + "<label for=\"subject\"><strong>subject</strong>: &nbsp;</LABEL>";

    try {
      if (subject == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + subject.toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String titleToHtml() {
    String s = "";

    s = s + "<label for=\"title\"><strong>title</strong>: &nbsp;</LABEL>";

    try {
      if (title == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + title.toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String committedToHtml() {
    String s = "";

    s = s + "<label for=\"committed\"><strong>committed</strong>: &nbsp;</LABEL>";

    try {
      if (committed == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + committed.toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String committerToHtml() {
    String s = "";

    s = s + "<label for=\"committer\"><strong>committer</strong>: &nbsp;</LABEL>";

    try {
      s = s + "<ul>";
      for (Link next : committer) {
        s = s + "<li>";
        if (next.getValue() == null) {
          s = s + "<em>null</em>";
        } else {
          s = s + "<a href=\"" + next.getValue().toString() + "\">" + next.getValue()
              .toString() + "</a>";
        }
        s = s + "</li>";
      }
      s = s + "</ul>";
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String componentToHtml() {
    String s = "";

    s = s + "<label for=\"component\"><strong>component</strong>: &nbsp;</LABEL>";

    try {
      s = s + "<ul>";
      Iterator<String> itr = component.iterator();
      while (itr.hasNext()) {
        s = s + "<li>";
        s = s + itr.next().toString();
        s = s + "</li>";
      }
      s = s + "</ul>";
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String versionIdToHtml() {
    String s = "";

    s = s + "<label for=\"versionId\"><strong>versionId</strong>: &nbsp;</LABEL>";

    try {
      if (versionId == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + versionId.toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String instanceShapeToHtml() {
    String s = "";

    s = s + "<label for=\"instanceShape\"><strong>instanceShape</strong>: &nbsp;</LABEL>";

    try {
      if (instanceShape == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + "<a href=\"" + instanceShape.toString() + "\">" + instanceShape.toString() + "</a>";
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String modifiedByToHtml() {
    String s = "";

    s = s + "<label for=\"modifiedBy\"><strong>modifiedBy</strong>: &nbsp;</LABEL>";

    try {
      if (modifiedBy.getValue() == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + modifiedBy.getValue().toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String serviceProviderToHtml() {
    String s = "";

    s = s + "<label for=\"serviceProvider\"><strong>serviceProvider</strong>: &nbsp;</LABEL>";

    try {
      if (serviceProvider == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + "<a href=\"" + serviceProvider.toString() + "\">" + serviceProvider.toString() +
            "</a>";
      }
    } catch (Exception e) {

      e.printStackTrace();
    }

    return s;
  }

  public String shortIdToHtml() {
    String s = "";

    s = s + "<label for=\"shortId\"><strong>shortId</strong>: &nbsp;</LABEL>";

    try {
      if (shortId == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + shortId.toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String shortTitleToHtml() {
    String s = "";

    s = s + "<label for=\"shortTitle\"><strong>shortTitle</strong>: &nbsp;</LABEL>";

    try {
      if (shortTitle == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + shortTitle.toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String typeToHtml() {
    String s = "";

    s = s + "<label for=\"type\"><strong>type</strong>: &nbsp;</LABEL>";

    try {
      if (type.getValue() == null) {
        s = s + "<em>null</em>";
      } else {
        s = s + type.getValue().toString();
      }
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String wasDerivedFromToHtml() {
    String s = "";

    s = s + "<label for=\"wasDerivedFrom\"><strong>wasDerivedFrom</strong>: &nbsp;</LABEL>";

    try {
      s = s + "<ul>";
      for (Link next : wasDerivedFrom) {
        s = s + "<li>";
        if (next.getValue() == null) {
          s = s + "<em>null</em>";
        } else {
          s = s + "<a href=\"" + next.getValue().toString() + "\">" + next.getValue()
              .toString() + "</a>";
        }
        s = s + "</li>";
      }
      s = s + "</ul>";
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

  public String wasRevisionOfToHtml() {
    String s = "";

    s = s + "<label for=\"wasRevisionOf\"><strong>wasRevisionOf</strong>: &nbsp;</LABEL>";

    try {
      s = s + "<ul>";
      for (Link next : wasRevisionOf) {
        s = s + "<li>";
        if (next.getValue() == null) {
          s = s + "<em>null</em>";
        } else {
          s = s + "<a href=\"" + next.getValue().toString() + "\">" + next.getValue()
              .toString() + "</a>";
        }
        s = s + "</li>";
      }
      s = s + "</ul>";
    } catch (Exception e) {
      e.printStackTrace();
    }

    return s;
  }

}
